#
# Copyright (c) 2006, Greggman (http://games.greggman.com)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# Redistributions of source code must retain the above copyright notice,this
# list of conditions and the following disclaimer.
#
# Redistributions binary form must reproduce the above copyright notice,
# this list ofconditions and the following disclaimer in the documentation
# and/or othermaterials provided with the distribution.
#
# Neither the name of Greggman nor the names of its contributors may be
# used to endorse orpromote products derived from this software without
# specific prior writtenpermission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
# CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
# NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# the latest version of this script can hopefully be found at
# http://games.greggman.com/pages/cutsprites/cutsprites.htm
#

use strict;
use warnings;

use File::Find;
use File::Basename;
use File::Spec;

my @psdFiles = ();

find ({
  wanted => \&checkFile,
  },
  '.');


for my $psdFilename (@psdFiles)
{
   my $tgaFilename = substr($psdFilename, 0, length($psdFilename) - 4) . ".tga";

#   $psdFilename = File::Spec->rel2abs( $psdFilename );
#   $tgaFilename = File::Spec->rel2abs( $tgaFilename );

   print "checking : $psdFilename vs $tgaFilename \n";

   my $bBuild = 0;

   # if the tga does not exist build it
   if (!(-e $tgaFilename))
   {
      #print "tga does not exist\n";
      $bBuild = 1;
   }
   else # if the tga is older than the psd build it
   {
      my $psdDate = getFileDate($psdFilename);
      my $tgaDate = getFileDate($tgaFilename);

      #print "psd data: $psdDate\n";
      #print "tga data: $tgaDate\n";

      if ($psdDate > $tgaDate)
      {
         $bBuild = 1;
      }
   }

   if ($bBuild)
   {
      my $cmd = "gfxinout.exe \"" . $psdFilename . "\" \"" . $tgaFilename . "\"";
      print $cmd . "\n";
      #system ($cmd, $psd) || die ("could not convert $psdFilename to $tgaFilename\n");
      system ("gfxinout.exe", $psdFilename, $tgaFilename) == 0
       or die ("could not convert $psdFilename to $tgaFilename\n");
   }
}

sub checkFile
{
   my $psdFilename = $File::Find::name;

   if ($psdFilename =~ /.psd$/i)
   {
      push(@psdFiles, $psdFilename);
   }
}

sub getFileDate
{
   my ($filename) = @_;

   my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);

   return $mtime;
}
